/******************************************************************************
 ******************************************************************************
 **                                                                          **
 **                              COPY_NW.NLM                                 **
 **                                                                          **
 **                                                                          **
 **      Copy _netware files utility                                         **
 **                                                                          **
 **      Copyright (c) CamaSoftware 1999-2000                                **
 **      Portions Copyright (c) Office-Net Kkt. 1999-2000                    ** 
 **      All rights reserved.                                                **
 **                                                                          **
 **      v1.0                                                                **
 **                                                                          **
 ******************************************************************************
 ******************************************************************************/

// Compiled with:
//    Metrowerks CodeWarrior Pro for Windows, Release 4
//    Metrowerks CodeWarrior PDK for NetWare, Release 2

/******************************************************************************
 *                                                                            *
 *       Header files                                                         *
 *                                                                            *
 ******************************************************************************/

//#define  N_PLAT_NLM
#define  N_IAPX386
#define _FIND_OLD_HEADERS_

#include <stdio.h>
//#include <stdlib.h>

#include <nwtypes.h>
#include <errno.h>
#include <nwerrno.h>
#include <sys/types.h>
#include <string.h>
#include <nwthread.h>
#include <nwconio.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <nwfinfo.h>
#include <sys/stat.h>

#include "copy_nw.h"

/******************************************************************************
 *                                                                            *
 *       Global variables                                                     *
 *                                                                            *
 ******************************************************************************/




void main( void )
{
	int		rc=0;
	DIR 	*dirStructP; 
	DIR		*direntp;
	char	path[255+1], filepath[255+1];
	int		f_SRC=-1, f_DST=-1;
	LONG	bytescopied;



	// Create the destination directory
	strcpy( path, "sys:/system/_netware" );
	mkdir( path, 0 );

	// Delete previous files found there
	strcpy( path, "sys:/system/_netware/*.*" );
	remove( path );
	
	strcpy( path, "sys:/_netware" );
	chdir( path );

	strcpy( path, "*.*" );
	if( (dirStructP = opendir(path)) != NULL ) 
		{
		ConsolePrintf( "\r\n\r\nCopying files from sys:_netware to sys:system/_netware ...\r\n" );

		ThreadSwitch();
		while( (direntp = readdir(dirStructP)) != NULL ) 
			{ 
			ConsolePrintf( "%12s  ...  ", &direntp->d_nameDOS );
			f_SRC = open( direntp->d_nameDOS, O_RDONLY | O_BINARY, 0 );
			if( f_SRC >= 0 )
				{
				sprintf( filepath, "sys:/system/_netware/%s", &direntp->d_nameDOS );
				f_DST = creat( filepath, 0 );
				if( f_DST >= -1 )
					{
					rc = FileServerFileCopy( f_SRC, f_DST, 0, 0, 0xFFFFFFF, &bytescopied );
					if( rc )
						{
						ConsolePrintf( "copy error [%d/%d/%d]\r\n", rc, errno, NetWareErrno );
						}
					else
						{
						ConsolePrintf( "done\r\n" );
						}
					close( f_DST );
					f_DST = -1;
					}
				else
					{
					ConsolePrintf( "create error [%d/%d/%d]\r\n", f_DST, errno, NetWareErrno );
					}
				close( f_SRC );
				f_SRC = -1;
				}
			else
				{
				ConsolePrintf( "open error [%d/%d/%d]\r\n", f_SRC, errno, NetWareErrno );
				}
			ThreadSwitch();
			} 
		closedir(dirStructP);
		ConsolePrintf( "Done.\r\n\r\n" );
		} 
	else
		{
		ConsolePrintf( "opendir error [%d/%d/%d]\r\n", NULL, errno, NetWareErrno );
		}



}



/******************************************************************************
 *                                                                            *
 *       End of source file                                                   *
 *                                                                            *
 ******************************************************************************/
